using System;
using System.Collections.Generic;

namespace rde
{
    public class MsgReceiver
    {
        public List<byte[]> OnDataReceived(byte[] dataBuffer, int receivedBytes)
        {
            List<byte[]> messages = new List<byte[]>();
            if (receivedBytes > 0)
            {
                int dataIndex = 0;

                if (m_pendingData != null)
                {
                    byte[] combinedBuffer = new byte[receivedBytes + m_pendingData.Length];
                    Array.Copy(m_pendingData, 0, combinedBuffer, 0, m_pendingData.Length);
                    Array.Copy(dataBuffer, 0, combinedBuffer, m_pendingData.Length, receivedBytes);
                    receivedBytes += m_pendingData.Length;
                    dataBuffer = combinedBuffer;
                    m_pendingData = null;
                }

                while (dataIndex < receivedBytes)
                {
                    if (receivedBytes - dataIndex <= 2)
                    {
                        SavePendingData(dataBuffer, dataIndex, receivedBytes);
                        break;
                    }

                    int messageSize = (dataBuffer[dataIndex] << 8) +
                        dataBuffer[dataIndex + 1];

                    if (receivedBytes - (dataIndex + 2) < messageSize)
                    {
                        SavePendingData(dataBuffer, dataIndex, receivedBytes);
                        break;
                    }
                    dataIndex += 2;
                    byte[] fullMessage = new byte[messageSize];
                    Array.Copy(dataBuffer, dataIndex, fullMessage, 0, messageSize);
                    dataIndex += messageSize;
                    messages.Add(fullMessage);
                    //HandleMessage(fullMessage);
                }
            }
            return messages;
        }
        void SavePendingData(byte[] data, int index, int len)
        {
            int toSave = len - index;
            m_pendingData = new byte[toSave];
            Array.Copy(data, index, m_pendingData, 0, toSave);
        }

        byte[] m_pendingData = null;
    };
}
