﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace rdeserver
{
    public partial class LastTasks : Form
    {
        static string[] s_resultCodeMessages = 
        {
            "Completed", "Failed", "Interrupted", "In progress"
        };

        public LastTasks(List<rdeserver.TaskResult> taskResults)
        {
            InitializeComponent();

            foreach (rdeserver.TaskResult res in taskResults)
            {
                string strErrorMessage = "";
                foreach (string msg in res.errorMessages)
                    strErrorMessage += msg + "\r\n";

                TimeSpan taskDuration = res.endTime - res.startTime;
                string strDuration = taskDuration.Hours.ToString("00") + ":" +
                    taskDuration.Minutes.ToString("00") + ":" +
                    taskDuration.Seconds.ToString("00");

                string[] data = {   res.taskName, s_resultCodeMessages[(int)res.code], 
                                    res.numItems.ToString(), strDuration, 
                                    res.numClients.ToString(), strErrorMessage };
                dgTasks.Rows.Add(data);
            }
        }

        private void dgTasks_CellPainting(object sender, DataGridViewCellPaintingEventArgs e)
        {
            foreach (DataGridViewRow row in dgTasks.Rows)
            {
                DataGridViewCell cell = row.Cells["colResult"];
                if (cell.Value.ToString() == s_resultCodeMessages[(int)rdeserver.TaskResult.Code.FAILED])
                    cell.Style.ForeColor = Color.Red;
                else if (cell.Value.ToString() == s_resultCodeMessages[(int)rdeserver.TaskResult.Code.COMPLETED])
                    cell.Style.ForeColor = Color.Green;
            }
        }
    }
}
